Package com.google.protobuf

## Class AbstractMessage.Builder<BuilderType extends AbstractMessage.Builder>

- java.lang.Object
- - com.google.protobuf.AbstractMessageLite.Builder<BuilderType>
  - - com.google.protobuf.AbstractMessage.Builder<BuilderType>

All Implemented Interfaces:
  `Message.Builder`, `MessageLite.Builder`, `MessageLiteOrBuilder`, `MessageOrBuilder`, `java.lang.Cloneable`

Direct Known Subclasses:
  `DynamicMessage.Builder`, `GeneratedMessage.Builder`

Enclosing class:
  AbstractMessage

    public abstract static class AbstractMessage.Builder<BuilderType extends AbstractMessage.Builder>
    extends AbstractMessageLite.Builder<BuilderType>
    implements Message.Builder

A partial implementation of the `Message.Builder` interface which implements as many methods of that interface as possible in terms of other methods.

### Constructor Summary

Constructors
`Builder()`

### Method Summary

All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
`BuilderType` `clear()` Resets all fields to their default values.
`BuilderType` `clearOneof​(Descriptors.OneofDescriptor oneof)` TODO(jieluo): Clear it when all subclasses have implemented this method.
`abstract BuilderType` `clone()` Clones the Builder.
`java.util.List<java.lang.String>` `findInitializationErrors()` Returns a list of field paths (e.g.
`Message.Builder` `getFieldBuilder​(Descriptors.FieldDescriptor field)` Get a nested builder instance for the given field.
`java.lang.String` `getInitializationErrorString()` Returns a comma-delimited list of required fields which are not set in this message object.
`Descriptors.FieldDescriptor` `getOneofFieldDescriptor​(Descriptors.OneofDescriptor oneof)` TODO(jieluo): Clear it when all subclasses have implemented this method.
`boolean` `hasOneof​(Descriptors.OneofDescriptor oneof)` TODO(jieluo): Clear it when all subclasses have implemented this method.
`boolean` `mergeDelimitedFrom​(java.io.InputStream input)` Like `MessageLite.Builder.mergeFrom(InputStream)`, but does not read until EOF.
`boolean` `mergeDelimitedFrom​(java.io.InputStream input, ExtensionRegistryLite extensionRegistry)` Like `MessageLite.Builder.mergeDelimitedFrom(InputStream)` but supporting extensions.
`BuilderType` `mergeFrom​(byte[] data)` Parse `data` as a message of this type and merge it with the message being built.
`BuilderType` `mergeFrom​(byte[] data, int off, int len)` Parse `data` as a message of this type and merge it with the message being built.
`BuilderType` `mergeFrom​(byte[] data, int off, int len, ExtensionRegistryLite extensionRegistry)` Parse `data` as a message of this type and merge it with the message being built.
`BuilderType` `mergeFrom​(byte[] data, ExtensionRegistryLite extensionRegistry)` Parse `data` as a message of this type and merge it with the message being built.
`BuilderType` `mergeFrom​(ByteString data)` Parse `data` as a message of this type and merge it with the message being built.
`BuilderType` `mergeFrom​(ByteString data, ExtensionRegistryLite extensionRegistry)` Parse `data` as a message of this type and merge it with the message being built.
`BuilderType` `mergeFrom​(CodedInputStream input)` Parses a message of this type from the input and merges it with this message.
`BuilderType` `mergeFrom​(CodedInputStream input, ExtensionRegistryLite extensionRegistry)` Like `MessageLite.Builder.mergeFrom(CodedInputStream)`, but also parses extensions.
`BuilderType` `mergeFrom​(Message other)` Merge `other` into the message being built.
`BuilderType` `mergeFrom​(java.io.InputStream input)` Parse a message of this type from `input` and merge it with the message being built.
`BuilderType` `mergeFrom​(java.io.InputStream input, ExtensionRegistryLite extensionRegistry)` Parse a message of this type from `input` and merge it with the message being built.
`BuilderType` `mergeUnknownFields​(UnknownFieldSet unknownFields)` Merge some unknown fields into the `UnknownFieldSet` for this message.
`protected static UninitializedMessageException` `newUninitializedMessageException​(Message message)` Construct an UninitializedMessageException reporting missing fields in the given message.
`java.lang.String` `toString()`

### Methods inherited from class com.google.protobuf.AbstractMessageLite.Builder

`addAll, newUninitializedMessageException`

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface com.google.protobuf.Message.Builder

`addRepeatedField, build, buildPartial, clearField, getDescriptorForType, newBuilderForField, setField, setRepeatedField, setUnknownFields`

### Methods inherited from interface com.google.protobuf.MessageLiteOrBuilder

`isInitialized`

### Methods inherited from interface com.google.protobuf.MessageOrBuilder

`getAllFields, getDefaultInstanceForType, getField, getRepeatedField, getRepeatedFieldCount, getUnknownFields, hasField`

### Constructor Detail

#### Builder

    public Builder()

### Method Detail

#### clone

    public abstract BuilderType clone()

Description copied from interface: `MessageLite.Builder`
Clones the Builder.

Specified by:
  `clone` in interface `Message.Builder`
Specified by:
  `clone` in interface `MessageLite.Builder`
Specified by:
  `clone` in class `AbstractMessageLite.Builder<BuilderType extends AbstractMessage.Builder>`
See Also:
  `Object.clone()`

#### hasOneof

    public boolean hasOneof​(Descriptors.OneofDescriptor oneof)

TODO(jieluo): Clear it when all subclasses have implemented this method.

Specified by:
  `hasOneof` in interface `MessageOrBuilder`

#### getOneofFieldDescriptor

    public Descriptors.FieldDescriptor getOneofFieldDescriptor​(Descriptors.OneofDescriptor oneof)

TODO(jieluo): Clear it when all subclasses have implemented this method.

Specified by:
  `getOneofFieldDescriptor` in interface `MessageOrBuilder`

#### clearOneof

    public BuilderType clearOneof​(Descriptors.OneofDescriptor oneof)

TODO(jieluo): Clear it when all subclasses have implemented this method.

Specified by:
  `clearOneof` in interface `Message.Builder`

#### clear

    public BuilderType clear()

Description copied from interface: `MessageLite.Builder`
Resets all fields to their default values.

Specified by:
  `clear` in interface `Message.Builder`
Specified by:
  `clear` in interface `MessageLite.Builder`

#### findInitializationErrors

    public java.util.List<java.lang.String> findInitializationErrors()

Description copied from interface: `MessageOrBuilder`
Returns a list of field paths (e.g. "foo.bar.baz") of required fields which are not set in this message. You should call `MessageLiteOrBuilder.isInitialized()` first to check if there are any missing fields, as that method is likely to be much faster than this one even when the message is fully-initialized.

Specified by:
  `findInitializationErrors` in interface `MessageOrBuilder`

#### getInitializationErrorString

    public java.lang.String getInitializationErrorString()

Description copied from interface: `MessageOrBuilder`
Returns a comma-delimited list of required fields which are not set in this message object. You should call `MessageLiteOrBuilder.isInitialized()` first to check if there are any missing fields, as that method is likely to be much faster than this one even when the message is fully-initialized.

Specified by:
  `getInitializationErrorString` in interface `MessageOrBuilder`

#### mergeFrom

    public BuilderType mergeFrom​(Message other)

Description copied from interface: `Message.Builder`
Merge `other` into the message being built. `other` must have the exact same type as `this` (i.e. `getDescriptorForType() == other.getDescriptorForType()`). Merging occurs as follows. For each field:
* For singular primitive fields, if the field is set in `other`, then `other`'s value overwrites the value in this message.
* For singular message fields, if the field is set in `other`, it is merged into the corresponding sub-message of this message using the same merging rules.
* For repeated fields, the elements in `other` are concatenated with the elements in this message. This is equivalent to the `Message::MergeFrom` method in C++.

Specified by:
  `mergeFrom` in interface `Message.Builder`

#### mergeFrom

    public BuilderType mergeFrom​(CodedInputStream input)
                          throws java.io.IOException

Description copied from interface: `MessageLite.Builder`
Parses a message of this type from the input and merges it with this message.

Warning: This does not verify that all required fields are present in the input message. If you call `MessageLite.Builder.build()` without setting all required fields, it will throw an `UninitializedMessageException`, which is a `RuntimeException` and thus might not be caught. There are a few good ways to deal with this:

- Call `MessageLiteOrBuilder.isInitialized()` to verify that all required fields are set before building.
- Use `buildPartial()` to build, which ignores missing required fields.

Note: The caller should call `CodedInputStream.checkLastTagWas(int)` after calling this to verify that the last tag seen was the appropriate end-group tag, or zero for EOF.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessageLite.Builder<BuilderType extends AbstractMessage.Builder>`
Throws:
  `java.io.IOException`

#### mergeFrom

    public BuilderType mergeFrom​(CodedInputStream input,
                                 ExtensionRegistryLite extensionRegistry)
                          throws java.io.IOException

Description copied from interface: `MessageLite.Builder`
Like `MessageLite.Builder.mergeFrom(CodedInputStream)`, but also parses extensions. The extensions that you want to be able to parse must be registered in `extensionRegistry`. Extensions not in the registry will be treated as unknown fields.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Specified by:
  `mergeFrom` in class `AbstractMessageLite.Builder<BuilderType extends AbstractMessage.Builder>`
Throws:
  `java.io.IOException`

#### mergeUnknownFields

    public BuilderType mergeUnknownFields​(UnknownFieldSet unknownFields)

Description copied from interface: `Message.Builder`
Merge some unknown fields into the `UnknownFieldSet` for this message.

Specified by:
  `mergeUnknownFields` in interface `Message.Builder`

#### getFieldBuilder

    public Message.Builder getFieldBuilder​(Descriptors.FieldDescriptor field)

Description copied from interface: `Message.Builder`
Get a nested builder instance for the given field.

Normally, we hold a reference to the immutable message object for the message type field. Some implementations(the generated message builders), however, can also hold a reference to the builder object (a nested builder) for the field.

If the field is already backed up by a nested builder, the nested builder will be returned. Otherwise, a new field builder will be created and returned. The original message field (if exist) will be merged into the field builder, which will then be nested into its parent builder.

NOTE: implementations that do not support nested builders will throw `UnsupportedException`.

Specified by:
  `getFieldBuilder` in interface `Message.Builder`

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `java.lang.Object`

#### newUninitializedMessageException

    protected static UninitializedMessageException newUninitializedMessageException​(Message message)

Construct an UninitializedMessageException reporting missing fields in the given message.

#### mergeFrom

    public BuilderType mergeFrom​(ByteString data)
                          throws InvalidProtocolBufferException

Description copied from interface: `MessageLite.Builder`
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream)`.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessageLite.Builder<BuilderType extends AbstractMessage.Builder>`
Returns:
  this
Throws:
  `InvalidProtocolBufferException`

#### mergeFrom

    public BuilderType mergeFrom​(ByteString data,
                                 ExtensionRegistryLite extensionRegistry)
                          throws InvalidProtocolBufferException

Description copied from interface: `MessageLite.Builder`
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessageLite.Builder<BuilderType extends AbstractMessage.Builder>`
Returns:
  this
Throws:
  `InvalidProtocolBufferException`

#### mergeFrom

    public BuilderType mergeFrom​(byte[] data)
                          throws InvalidProtocolBufferException

Description copied from interface: `MessageLite.Builder`
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream)`.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessageLite.Builder<BuilderType extends AbstractMessage.Builder>`
Returns:
  this
Throws:
  `InvalidProtocolBufferException`

#### mergeFrom

    public BuilderType mergeFrom​(byte[] data,
                                 int off,
                                 int len)
                          throws InvalidProtocolBufferException

Description copied from interface: `MessageLite.Builder`
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream)`.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessageLite.Builder<BuilderType extends AbstractMessage.Builder>`
Returns:
  this
Throws:
  `InvalidProtocolBufferException`

#### mergeFrom

    public BuilderType mergeFrom​(byte[] data,
                                 ExtensionRegistryLite extensionRegistry)
                          throws InvalidProtocolBufferException

Description copied from interface: `MessageLite.Builder`
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessageLite.Builder<BuilderType extends AbstractMessage.Builder>`
Returns:
  this
Throws:
  `InvalidProtocolBufferException`

#### mergeFrom

    public BuilderType mergeFrom​(byte[] data,
                                 int off,
                                 int len,
                                 ExtensionRegistryLite extensionRegistry)
                          throws InvalidProtocolBufferException

Description copied from interface: `MessageLite.Builder`
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessageLite.Builder<BuilderType extends AbstractMessage.Builder>`
Returns:
  this
Throws:
  `InvalidProtocolBufferException`

#### mergeFrom

    public BuilderType mergeFrom​(java.io.InputStream input)
                          throws java.io.IOException

Description copied from interface: `MessageLite.Builder`
Parse a message of this type from `input` and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream)`. Note that this method always reads the entire input (unless it throws an exception). If you want it to stop earlier, you will need to wrap your input in some wrapper stream that limits reading. Or, use `MessageLite.writeDelimitedTo(OutputStream)` to write your message and `MessageLite.Builder.mergeDelimitedFrom(InputStream)` to read it.

Despite usually reading the entire input, this does not close the stream.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessageLite.Builder<BuilderType extends AbstractMessage.Builder>`
Returns:
  this
Throws:
  `java.io.IOException`

#### mergeFrom

    public BuilderType mergeFrom​(java.io.InputStream input,
                                 ExtensionRegistryLite extensionRegistry)
                          throws java.io.IOException

Description copied from interface: `MessageLite.Builder`
Parse a message of this type from `input` and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessageLite.Builder<BuilderType extends AbstractMessage.Builder>`
Returns:
  this
Throws:
  `java.io.IOException`

#### mergeDelimitedFrom

    public boolean mergeDelimitedFrom​(java.io.InputStream input)
                               throws java.io.IOException

Description copied from interface: `MessageLite.Builder`
Like `MessageLite.Builder.mergeFrom(InputStream)`, but does not read until EOF. Instead, the size of the message (encoded as a varint) is read first, then the message data. Use `MessageLite.writeDelimitedTo(OutputStream)` to write messages in this format.

Specified by:
  `mergeDelimitedFrom` in interface `Message.Builder`
Specified by:
  `mergeDelimitedFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeDelimitedFrom` in class `AbstractMessageLite.Builder<BuilderType extends AbstractMessage.Builder>`
Returns:
  True if successful, or false if the stream is at EOF when the method starts. Any other error (including reaching EOF during parsing) will cause an exception to be thrown.
Throws:
  `java.io.IOException`

#### mergeDelimitedFrom

    public boolean mergeDelimitedFrom​(java.io.InputStream input,
                                      ExtensionRegistryLite extensionRegistry)
                               throws java.io.IOException

Description copied from interface: `MessageLite.Builder`
Like `MessageLite.Builder.mergeDelimitedFrom(InputStream)` but supporting extensions.

Specified by:
  `mergeDelimitedFrom` in interface `Message.Builder`
Specified by:
  `mergeDelimitedFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeDelimitedFrom` in class `AbstractMessageLite.Builder<BuilderType extends AbstractMessage.Builder>`
Throws:
  `java.io.IOException`